# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/05_util/01_core.ipynb.

# %% auto 0
__all__ = ['toprivate', 'tomangled', 'tosunder', 'todunder', 'getcard', 'iscard', 'is1char']

# %% ../../nbs/05_util/01_core.ipynb 4
from numbers import Number
from typing import Optional
import os, pathlib

# %% ../../nbs/05_util/01_core.ipynb 5
from ..nchr import DOT, NIL
from chck import isprivate, ismangled, issunder, isdunder

# %% ../../nbs/05_util/01_core.ipynb 6
def toprivate(s: str) -> str:
    return f'_{s}' if not isprivate(s) else s

def tomangled(s: str) -> str:
    return f'__{s}' if not ismangled(s) else s

def tosunder(s: str) -> str:
    return f'_{s}_' if not issunder(s) else s

def todunder(s: str) -> str:
    return f'__{s}__' if not isdunder(s) else s

# %% ../../nbs/05_util/01_core.ipynb 7
def getcard(s: str) -> int:
    '''Returns the cardinality of the set of characters for the string.'''
    return len(set(s))

def iscard(s: str, n: int = 1) -> bool:
    '''Checks if a string is composed of a set of `n` characters.'''
    return getcard(s) == n

def is1char(s: str) -> bool:
    '''Checks if a string is composed of a single unique character.'''
    return iscard(s, 1)
